#define AELI 6378.388     // Semi-major axis
#define BELI 6356.912     // Semi-minor axis
#define POLOMER 6371.3    // Polomer zemekoule pro bezny vypocet

PRIVATE cl:=0,dl:=0,cbl:=0,dbl:=0,frame:="ͻȺ ",vlastniloc:="      ",;
   qrr:={0,0},elipsa:=.F.
CLEAR SCREEN
SET(_SET_SCOREBOARD,.F.)

SETCOLOR("GR+/B")
elipsa()
vlloc()
DISPBOX(0,0,14,31,frame)
@ 0,3 SAY "[Vlastni lokator: "+vlastniloc+" ]"
@ 13,1 SAY "        (ESC - konec)         " COLO "W/B"
IF elipsa
   @ 14,5 SAY "[Elipticka zemekoule]"
ENDIF
DO WHILE .T.
   lokator()
   IF LASTKEY()=27
      EXIT
   ENDIF
ENDDO
QUIT

***KONTROLA SPRAVNOSTI LOKATORU
FUNCTION kontrloc(loc)
LOCAL kontr:=1
IF VALTYPE(loc)!="C"
   RETURN 0
ENDIF
IF LEN(loc)#6.OR.LEFT(loc,1)<"A".OR.LEFT(loc,1)>"R".OR.;
   SUBSTR(loc,2,1)<"A".OR.SUBSTR(loc,2,1)>"R".OR.;
   SUBSTR(loc,3,1)<"0".OR.SUBSTR(loc,3,1)>"9".OR.;
   SUBSTR(loc,4,1)<"0".OR.SUBSTR(loc,4,1)>"9".OR.;
   SUBSTR(loc,5,1)<"A".OR.SUBSTR(loc,5,1)>"X".OR.;
   RIGHT(loc,1)<"A".OR.RIGHT(loc,1)>"X"
   kontr:=0
ENDIF
RETURN kontr
*EOF kontrloc

***SPOCTI
FUNCTION spocti(pole,kontrola)
LOCAL vysl:={0,0,0,0},r:=PI()/180,i:=0,jj:=0,gg:=0
IIF(kontrola=nil,kontrola:=.T.,nil)
IIF(LEN(pole)>6,ppole:=pole[7],ppole:=pole)
IF kontrloc(ppole)#1
   IF kontrola
      @ 13,1 SAY "Chybny lokator,Cokoliv stiskni"
      inkey(0)
      @ 13,1 SAY "        (ESC - konec)         " COLO "W/B"
   ENDIF
   RETURN vysl
ENDIF
qrr:=prevedvzd(ppole)
i:=qrr[1]-cl
IF cl=qrr[1].AND.dl=qrr[2]
   vysl[1]:=0  //qrb vlastni loc
   vysl[2]:=2  //body vlastni loc
   vysl[3]:=0
   vysl[4]:=0
ELSE
   // Vzdalenost !!!
   IF elipsa
      vysl[1]:=ROUND(countelip(dl,cl,qrr[2],qrr[1]),1)
   ELSE
      vysl[1]:=ROUND(POLOMER*ACOS(SIN(dl)*SIN(qrr[2])+COS(dl)*COS(qrr[2])*COS(i)),0)
   ENDIF

   // Azimut !!!
   jj:=TAN(qrr[2])*COS(dl)-SIN(dl)*COS(i)
   IF jj#0
      gg:=ABS(ATAN(SIN(i)/jj))
      IIF(jj<0,gg:=PI()-gg,nil)
      IIF(i<0,gg:=2*PI()-gg,nil)
      vysl[3]:=ROUND(gg/r,0)
      vysl[4]:=vysl[3]-180
      IIF(vysl[4]<0,vysl[4]:=vysl[4]+360,nil)
      IIF(vysl[3]=0,vysl[3]:=360,nil)
   ENDIF

   // Body !!!
   qrr:=prevedbody(ppole)
   IF ABS(cbl-qrr[1])<ABS(dbl-qrr[2])
      vysl[2]:=INT(ABS(dbl-qrr[2])+2)
   ELSE
      vysl[2]:=INT(ABS(cbl-qrr[1])+2)
   ENDIF
ENDIF
RETURN vysl
*EOF spocti

***COUNTELI
*** Full distance calculation on elliptical earth (non-optimised).
*** John Morris, GM4ANB, 1994.
FUNCTION countelip(lat1, lon1, lat2, lon2)
LOCAL e, si, co, th, ca, a1, a2, l1, l2, ep
e = 1 - (BELI * BELI) / (AELI * AELI)   // Eccentricity squared

// Convert latitudes to geocentric
lat1 = ATAN((BELI * BELI) / (AELI * AELI) * TAN(lat1))
lat2 = ATAN((BELI * BELI) / (AELI * AELI) * TAN(lat2))

// Calculate central angle
ca = ACOS(SIN(lat1)*SIN(lat2)+COS(lat1)*COS(lat2)*COS(lon2-lon1))

// Calculate angles along great ellipse from equator
IF (lat1 > lat2)
   t = lat2
   lat2 = lat1
   lat1 = t
ENDIF
si = SIN(lat1) * SIN(ca)
co = SIN(lat2) - SIN(lat1) * COS(ca)
a1 = ATN2(si, co)
a2 = a1 + ca

// Calculate ellipticity (squared) of great circle
th = SIN(lat2) / SIN(a2)
ep = e * th * th

// Calculate great circle distance from equator for each

l1 = AELI * (a1 - ep * a1 / 4 + ep * SIN(2 * a1) / 8)
l2 = AELI * (a2 - ep * a2 / 4 + ep * SIN(2 * a2) / 8)

RETURN l2 - l1
*EOF countelip

***PREVEDBODY
FUNCTION prevedbody(q)
LOCAL l:={0,0}
l[1]:=10*(ASC(SUBSTR(q,2,1))-65)+(VAL(SUBSTR(q,4,1)))
l[2]:=10*(ASC(LEFT(q,1))-65)+(VAL(SUBSTR(q,3,1)))
RETURN l
*EOF prevedbody

***PREVEDVZD
FUNCTION prevedvzd(q)
LOCAL l:={0,0},r:=PI()/180
l[1]:=r*((ASC(LEFT(q,1))-74)*20+(VAL(SUBSTR(q,3,1)))*2+(ASC(SUBSTR(q,5,1))-65)/12)
l[2]:=r*((ASC(SUBSTR(q,2,1))-74)*10+(VAL(SUBSTR(q,4,1)))+(ASC(RIGHT(q,1))-65)/24)
RETURN l
*EOF prevedvzd

***LOKATOR
FUNCTION lokator()
LOCAL loc:="      ",vysl:={0,0,0,0}
@ 12,4 SAY " Vloz lokator: "
DO WHILE .T.
   @ 12,19 GET loc PICT "@!"
   READ
   IF LASTKEY()=27
      EXIT
   ENDIF
   vysl:=spocti(loc)
   IF vysl[1]=0
      LOOP
   ENDIF
   pislokator(vysl[3],vysl[4],vysl[1],loc)
   EXIT
ENDDO
RETURN nil
*EOF lokator

***PISLOKATOR
FUNCTION pislokator(azim,azimb,qr,loc)
LOCAL mm:={" "," "," "," "," "," "," "},;
      m:={"","","","","","",""}
   azim:=str(azim,3)
   m:=velkecislo(LEFT(azim,1))
   mm[1]:=mm[1]+m[1]+"  "
   mm[2]:=mm[2]+m[2]+"  "
   mm[3]:=mm[3]+m[3]+"  "
   mm[4]:=mm[4]+m[4]+"  "
   mm[5]:=mm[5]+m[5]+"  "
   mm[6]:=mm[6]+m[6]+"  "
   mm[7]:=mm[7]+m[7]+"  "
   m:=velkecislo(SUBSTR(azim,2,1))
   mm[1]:=mm[1]+m[1]+"  "
   mm[2]:=mm[2]+m[2]+"  "
   mm[3]:=mm[3]+m[3]+"  "
   mm[4]:=mm[4]+m[4]+"  "
   mm[5]:=mm[5]+m[5]+"  "
   mm[6]:=mm[6]+m[6]+"  "
   mm[7]:=mm[7]+m[7]+"  "
   m:=velkecislo(RIGHT(azim,1))
   mm[1]:=mm[1]+m[1]+"    "
   mm[2]:=mm[2]+m[2]+"     "
   mm[3]:=mm[3]+m[3]+"  "
   mm[4]:=mm[4]+m[4]+"       "
   mm[5]:=mm[5]+m[5]+"       "
   mm[6]:=mm[6]+m[6]+"       "
   mm[7]:=mm[7]+m[7]+"       "
   @ 1,7 SAY "Do lokatoru:  "+loc
   IF elipsa
      @ 2,7 SAY " Vzdalenost: "+STR(qr,7,1)+" km"
   ELSE
      @ 2,7 SAY " Vzdalenost: "+STR(qr,6,0)+" km"
   ENDIF
   @ 3,1 SAY mm[1]
   @ 4,1 SAY mm[2]
   @ 5,1 SAY mm[3]
   @ 6,1 SAY mm[4]
   @ 7,1 SAY mm[5]
   @ 8,1 SAY mm[6]
   @ 9,1 SAY mm[7]
   @ 10,1 SAY SPACE(30)
   @ 11,6 SAY "Azimut zpet: "+STR(azimb,3,0)+" st."
RETURN nil
*EOF pislokator

***VELKECISLO
FUNCTION velkecislo(n)
LOCAL m:={"","","","","","",""}
DO CASE
CASE n=" "
   m[1]:="      "
   m[2]:="      "
   m[3]:="      "
   m[4]:="      "
   m[5]:="      "
   m[6]:="      "
   m[7]:="      "
CASE n="0"
   m[1]:="  "
   m[2]:="  "
   m[3]:="    "
   m[4]:="    "
   m[5]:="    "
   m[6]:="    "
   m[7]:="  "
CASE n="1"
   m[1]:="     "
   m[2]:="   "
   m[3]:="    "
   m[4]:="     "
   m[5]:="     "
   m[6]:="     "
   m[7]:=" "
CASE n="2"
   m[1]:="  "
   m[2]:="    "
   m[3]:="     "
   m[4]:="     "
   m[5]:="     "
   m[6]:="     "
   m[7]:=""
CASE n="3"
   m[1]:="  "
   m[2]:="    "
   m[3]:="     "
   m[4]:="     "
   m[5]:="  "
   m[6]:="    "
   m[7]:=""
CASE n="4"
   m[1]:="     "
   m[2]:="    "
   m[3]:="    "
   m[4]:="   "
   m[5]:=""
   m[6]:="     "
   m[7]:=" "
CASE n="5"
   m[1]:="  "
   m[2]:="     "
   m[3]:="     "
   m[4]:="     "
   m[5]:=" "
   m[6]:="     "
   m[7]:=""
CASE n="6"
   m[1]:="  "
   m[2]:="    "
   m[3]:="     "
   m[4]:="     "
   m[5]:=""
   m[6]:="    "
   m[7]:=""
CASE n="7"
   m[1]:=" "
   m[2]:="     "
   m[3]:="     "
   m[4]:="     "
   m[5]:="     "
   m[6]:="     "
   m[7]:="     "
CASE n="8"
   m[1]:="  "
   m[2]:="    "
   m[3]:="    "
   m[4]:="    "
   m[5]:=""
   m[6]:="    "
   m[7]:=""
CASE n="9"
   m[1]:="  "
   m[2]:="    "
   m[3]:="    "
   m[4]:="    "
   m[5]:=" "
   m[6]:="     "
   m[7]:=""
ENDCASE
RETURN m
*EOF velkecislo

***VLLOC
FUNCTION vlloc()
DISPBOX(0,0,14,31,frame)
@  1,1 SAY "      !!! LOCAXH.EXE !!!      "
@  3,1 SAY "   Tento jednoduchy program   "
@  4,1 SAY "  slouzi k zobrazeni azimutu, "
@  5,1 SAY "vzdalenosti a zpetneho azimutu"
@  6,1 SAY "   do lokatoru protistanice.  "
IF elipsa
   @  7,1 SAY "Pocita s  eliptickou zemekouli"
   @  8,1 SAY "s polomery "+STR(AELI,8,3)+" / "+STR(BELI,8,3)
ELSE
   @  7,1 SAY " Pocita s polomerem zemekoule "
   @  8,1 SAY "          "+STR(POLOMER,6,1)+" km.          "
ENDIF
@ 10,1 SAY "       (c) OK1AXH 2001        "
@ 13,1 SAY "        (ESC - konec)         " COLO "W/B"
@ 12,2 SAY "Vlastni lokator: "
DO WHILE .T.
   @ 12,19 GET vlastniloc PICT "@!"
   READ
   IF LASTKEY()=27
      QUIT
   ENDIF
   IF kontrloc(vlastniloc)=1
      qrr:=prevedbody(vlastniloc)
      cbl:=qrr[1]
      dbl:=qrr[2]
      qrr:=prevedvzd(vlastniloc)
      cl:=qrr[1]
      dl:=qrr[2]
      EXIT
   ELSE
      @ 13,1 SAY "Chybny vlastni lokator."
      inkey(0)
      @ 13,1 SAY "        (ESC - konec)         " COLO "W/B"
   ENDIF
ENDDO
RETURN nil
*EOF vlloc

***ELIPSA
FUNCTION elipsa()
DISPBOX(0,0,14,31,frame)
@  1,1 SAY "      !!! LOCAXH.EXE !!!      "
@  3,1 SAY " V nove verzi tohoto programu " COLO "W+/B"
@  4,1 SAY " byla pridana moznost pocitat " COLO "W+/B"
@  5,1 SAY "   vzdalenosti podle GM4ANB   " COLO "W+/B"
@  6,1 SAY "na elipticke zemekouli s polo-" COLO "W+/B"
@  7,1 SAY "mery                          " COLO "W+/B"
@  7,8 SAY STR(AELI,8,3)+"  /  "+STR(BELI,8,3)
@  8,1 SAY "(Internation.elipsoid of 1924)" COLO "W+/B"
@ 10,1 SAY "   Pokud chcete pocitat QRB   " COLO "W+/B"
@ 11,1 SAY " pro EME  nebo presne rekordy " COLO "W+/B"
@ 12,1 SAY "  potvrdte stiskem         !  " COLO "W+/B"
@ 12,22 SAY "- A -"
@ 13,1 SAY " (ostatni - normalni vypocet) " COLO "W+/B"
SETPOS(12,24)
inkey(0)
IF CHR(LASTKEY())$"AaYy"
   elipsa:=.T.
ENDIF
RETURN nil
*EOF elipsa
